/*
	Copyright 2008 Xavier Dunat

    This file is part of Suisse.

    Suisse is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Suisse is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Suisse; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "pass.h"
#include "joueur.h"
#include "fileout.h"
#include "log.h"

void createEntete(FILE *writeFile, char *nameTitle) {
	fprintf(writeFile,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Frameset//EN\"\n");
	fprintf(writeFile,"	  \"http://www.w3.org/TR/REC-html40/frame.dtd\">\n");
	fprintf(writeFile,"<html>\n<head>\n");
	fprintf(writeFile,"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">");
	fprintf(writeFile,"<title>%s</title>", nameTitle);
	fprintf(writeFile,"</head>\n");
}
int createFicheIndiv(int numPairing) {
	FILE *writeFile;
	int round, moyenne=0, orderAdv, numAdvTheo, numAdvReal;
	char surname[SIZE_NAME], name[SIZE_NAME];
	char eloAdv[7], numAdv[7], resultat[7], color[7];
	char fileName[128];
	double result;
	
	if (numPairing >= g_listPlayer.nbPlayer) return(OK);

	sprintf(fileName, "fiche%d.html", numPairing);
	writeFile=fopen(fileName, "w");
	if (!writeFile) {
		STD_LOG("createFicheIndiv")("Création impossible");
		return(NOK);
	}
	strcpy(surname, g_listPlayer.Player[Pairing2Order(numPairing)].surname);
	strcpy(name, g_listPlayer.Player[Pairing2Order(numPairing)].name);
	createEntete(writeFile, surname);
	fprintf(writeFile,"<body>");
	fprintf(writeFile,"<div align='center'>\n<table border='1' cellpadding='0' cellspacing='0' bordercolor='#000000'>\n");
	fprintf(writeFile,"<tr><td><table border='0' cellpadding='2' cellspacing='0' width='400'>\n<tr>");
	fprintf(writeFile,"<td align='center' valign='middle' width='50'><h2>&nbsp;</h2></td>\n");
	fprintf(writeFile,"    <td align='center' valign='middle' width='300'><font><b>%s</b></font></td>\n", nameTournament);
	fprintf(writeFile,"    <td align='center' valign='middle' width='50'><h2>%d</h2></td>\n", numPairing);
	fprintf(writeFile,"</table></td></tr>");
	fprintf(writeFile,"	<tr><td><table border='0' cellpadding='2' cellspacing='0' width='400'>");
	fprintf(writeFile,"  <tr>\n    <td align='right' width='80'><font><b>Nom :&nbsp;</b></font></td>");
	fprintf(writeFile,"    <td align= 'left' colspan='3'><font><b> %s %s</b></font></td>\n  </tr>\n  <tr>", surname, name);
	fprintf(writeFile,"    <td align='right' width='80'><font><b>Fide ID :&nbsp;</b></font></td>\n");
	fprintf(writeFile,"    <td align='left' width='160'><font></font></td>\n");
	fprintf(writeFile,"    <td align='right' width='60'><font><b>F&eacute;d&eacute;ration :&nbsp;</b></font></td>\n");
	fprintf(writeFile,"    <td align='left'><font></font></td>\n  </tr>\n  <tr>");
	fprintf(writeFile,"    <td align='right' width='80'><font><b>NrFFE :&nbsp;</b></font></td>\n");
	fprintf(writeFile,"    <td align='left' width='160'><font></font></td>\n");
	fprintf(writeFile,"    <td align='right' width='60'><font><b>Elo :&nbsp;</b></font></td>\n");
	fprintf(writeFile,"    <td align='left'><font>%d</font></td>", g_listPlayer.Player[Pairing2Order(numPairing)].elo);
	fprintf(writeFile,"  </tr>\n</table></td></tr>\n");
	fprintf(writeFile,"<tr><td><table border='1' cellpadding='2' cellspacing='0'  bordercolor='#000000' width='400'>\n");
	fflush(writeFile);
	for (round=1; round<=g_nbRound; round++) {
		numAdvReal=g_listPlayer.Player[Pairing2Order(numPairing)].numAdv[round];
		numAdvTheo=g_listPlayer.Player[Pairing2Order(numPairing)].numAdvTheorique[round];
		orderAdv=Pairing2Order(numAdvTheo);
		if (numAdvReal!=0) {
			STD_LOG("createFicheIndiv")("joueur %d adv %d", numPairing, orderAdv);
			sprintf(eloAdv, "%d", g_listPlayer.Player[orderAdv].elo);
			strcpy(surname, g_listPlayer.Player[orderAdv].surname);
			sprintf(numAdv, "%d", g_listPlayer.Player[Pairing2Order(numPairing)].numAdvTheorique[round]);
			result=g_listPlayer.Player[Pairing2Order(numPairing)].resultat[round];
			if (result!=NO_SCORE)
				sprintf(resultat, "%3.1f", result);
			else
				sprintf(resultat, "&nbsp;");
			if (g_listPlayer.Player[orderAdv].color[round]==BLACK)
				sprintf(color, "B");
			else
				sprintf(color, "N");
		} else {
			if (g_listPlayer.Player[Pairing2Order(numPairing)].resultat[round]!=NO_SCORE) {
				sprintf(eloAdv, "%d", g_listPlayer.Player[orderAdv].elo);
				if (numAdvTheo==0) {
					strcpy(eloAdv,"&nbsp;");
					strcpy(surname,"EXEMPT");
					strcpy(numAdv,"0");
					sprintf(resultat,"1f", result);
					strcpy(color, "&nbsp;");
				}
				else {
					strcpy(surname, g_listPlayer.Player[orderAdv].surname);
					sprintf(numAdv, "%d", numAdvTheo);
					if (g_listPlayer.Player[orderAdv].colorTheorique[round]==BLACK)
						sprintf(color, "b");
					else
						sprintf(color, "n");
					result=g_listPlayer.Player[Pairing2Order(numPairing)].resultat[round];
					sprintf(resultat, "%3.1ff", result);
				}
			} else {
				result=g_listPlayer.Player[Pairing2Order(numPairing)].resultat[round];
				strcpy(eloAdv,"&nbsp;");
				strcpy(surname,"&nbsp;");
				strcpy(numAdv,"&nbsp;");
				sprintf(resultat,"&nbsp;", result);
				strcpy(color, "&nbsp;");
			}
		}
		fprintf(writeFile,"  <tr>\n    <td align='center' width='20'><font>%d</font></td>\n", round);
		fprintf(writeFile,"    <td align='center' width='30'><font>%s</font></td>\n", numAdv);
		fprintf(writeFile,"    <td align='center' width='20'><font>%s</font></td>\n", color);
		fprintf(writeFile,"    <td align='left' width='230'><font>%s</font></td>\n", surname);
		fprintf(writeFile,"    <td align='center' width='40'><font>&nbsp;</font></td>\n");
		fprintf(writeFile,"    <td align='right' width='40'><font>%s</font></td>\n", eloAdv);
		fprintf(writeFile,"    <td align='center' width='30'><font>%s</font></td>\n  </tr>\n", resultat);
		fflush(writeFile);
	}
	fprintf(writeFile,"</table></td></tr>\n");
	fprintf(writeFile,"<tr><td><table border='0' cellpadding='2' cellspacing='0' width='400'>\n  <tr>");
	fprintf(writeFile,"    <td align='right' width='210'><font><b>Moyenne adverse :&nbsp;</b></font></td>\n");
	fprintf(writeFile,"    <td align='left' width='60'><font>%d</font></td>\n", moyenne);
	fprintf(writeFile,"    <td><font>%3.1f / %d</font></td>\n", g_listPlayer.Player[Pairing2Order(numPairing)].score, g_round);
	fprintf(writeFile,"    <td align='center' width='30'><font>%d</font></td>\n",0);
	fprintf(writeFile,"  </tr>\n</table></td></tr>\n");

  	fprintf(writeFile,"</tr>\n");
	fprintf(writeFile,"</body></html>");
	fflush(writeFile);
	fclose(writeFile);
	return (OK);
}

void createFilePairing() {
	FILE *writeFile;
	int table;
	char fileName[128], bgcolor[8];

	sprintf(fileName, "%s%d.html", nameTournament, g_round);
	writeFile=fopen(fileName, "w");
	if (!writeFile) {
		STD_LOG("createFicheIndiv")("Création impossible");
	}
	createEntete(writeFile, "appariement");
	fprintf(writeFile,"<body>\n");
	fprintf(writeFile,"<table border='0' cellpadding='2' cellspacing='0' bordercolor='#000000'>\n");
	fprintf(writeFile,"  <tr><td colspan='8' align='center'><h1><b>%s<br>Appariements de la ronde %d</h1></td></tr>\n  <tr>\n", nameTournament, g_round);
	fprintf(writeFile,"    <td align='center'><font><b>Ech.</b></font></td>\n");
	fprintf(writeFile,"    <td align='center'><font><b>Pts</b></font></td>\n");
	fprintf(writeFile,"    <td align='left'><font><b>Blancs</b></font></td>\n");
	fprintf(writeFile,"    <td align='right'><font><b>&nbsp;</b></font></td>\n");
	fprintf(writeFile,"    <td align='center'><font><b>Res.</b></font></td>\n");
	fprintf(writeFile,"    <td align='left'><font><b>Noirs</b></font></td>\n");
	fprintf(writeFile,"    <td align='right'><font><b>&nbsp;</b></font></td>\n");
	fprintf(writeFile,"    <td align='center'><font><b>Pts</b></font></td>\n");
	fprintf(writeFile,"  </tr>\n");
	fflush(writeFile);
	strcpy(bgcolor, "#FFFFFF");
	for (table=0; table<g_nbTable[g_round]; table++) {
		fprintf(writeFile,"  <tr>\n");
		if (strcmp(bgcolor, "#FFFFFF"))
			strcpy(bgcolor, "#FFFFFF");
		else
			strcpy(bgcolor, "#E0E0E0");
		fprintf(writeFile,"    <td align='center' bgcolor='%s'><font>%d</font></td>\n", bgcolor, table+1);
		fprintf(writeFile,"    <td align='center' bgcolor='%s'><font>[%3.1f]</font></td>\n", bgcolor, g_listTable[g_round-1][table].white.score);
		fprintf(writeFile,"    <td align='left' bgcolor='%s'><font>%s %s</font></td>\n", bgcolor, g_listTable[g_round-1][table].white.surname, g_listTable[g_round-1][table].white.name);
		fprintf(writeFile,"    <td align='right' bgcolor='%s'><font>%d</font></td>\n", bgcolor, g_listTable[g_round-1][table].white.elo);
		fprintf(writeFile,"    <td align='center' bgcolor='%s'><font>&nbsp;</font></td>\n", bgcolor);
		fprintf(writeFile,"    <td align='left' bgcolor='%s'><font>%s %s</font></td>\n", bgcolor, g_listTable[g_round-1][table].black.surname, g_listTable[g_round-1][table].black.name);
		fprintf(writeFile,"    <td align='right' bgcolor='%s'><font>%d</font></td>\n", bgcolor, g_listTable[g_round-1][table].black.elo);
		fprintf(writeFile,"    <td align='center' bgcolor='%s'><font>[%3.1f]</font></td>\n", bgcolor, g_listTable[g_round-1][table].black.score);
		fprintf(writeFile,"  </tr>\n");
		fflush(writeFile);
	}
	fprintf(writeFile,"</table></div></body></html>");
	fflush(writeFile);
	fclose(writeFile);
}
