/*
	Copyright 2003-2008 Xavier Dunat

    This file is part of Suisse.

    Suisse is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Suisse is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Suisse; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef	_Player_h_
#define	_Player_h_
#define MAX_ROUND 14
#define NO_SCORE -10

//#define SIZE_NAME 20
enum TITLE {noTitle, Fide, MFideF, MFide, MIF, MI, GMF, GMI};
enum COLOR {WHITE = -1, NOPLAY = 0, BLACK = +1};
struct player {
	char name[SIZE_NAME];
	char surname[SIZE_NAME];
	enum TITLE title;
	int elo;
	double resultat[MAX_ROUND];
	double score;
	int numPairing;
	int numAdv[MAX_ROUND];
	int numAdvTheorique[MAX_ROUND];
	enum COLOR color[MAX_ROUND];
	enum COLOR colorTheorique[MAX_ROUND];
	int flotteur[MAX_ROUND];
	int flotteurTheorique[MAX_ROUND];
	int exempt[MAX_ROUND];
	int out[MAX_ROUND];
	double cumulatif;
	double solkoff;
	double scoreAjuste;
};

struct listOfPlayer {
	struct player *Player;
	int nbPlayer;
};

struct table {
	struct player white;
	struct player black;
	char result[8];
};
struct perturbation {
	int low;
	int hight;
	enum COLOR color;
};
struct listOfPlayer g_listPlayer;
struct table **g_listTable;
enum COLOR g_colorNum1;
extern struct player playerExempt;
int g_nbNotPaired;
int *g_nbTable, *g_nbPlayerOut;
	
int inversePlayer(struct player *list,int player1, int player2);
int triPlayer(struct player *list, int number);
int getPlayer();
int setPlayerWithParam(char *surname, char *name, int elo, int title);
int getAllResult();
int getResult(int numPlayer, char *Result);
int setMatch(struct player *player0, struct player *player1);
int Pairing2Order(int numPairing);
int getOrder(int numPairing, struct player *list);
int getOutOnePlayer(int numApp, int numRoundMin, int numRoundMax);
int copyStructPlayer (struct player *source, struct player *dest, int nbPlayer);
int copyListOfPlayer (struct listOfPlayer source, struct listOfPlayer *dest);
int nbRoundSet();
void numPairing(struct listOfPlayer);
void initExempt();
#endif /* _Player_h_ */
