/*
	Copyright 2003-2008 Xavier Dunat

    This file is part of Suisse.

    Suisse is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Suisse is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Suisse; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <gtk/gtk.h>
#ifndef PASS_H
#define PASS_H
#define VERSION "version 0.0.6-alpha2"

#define OK 0
#define NOK 1
#define SIZE_NAME 1024

enum { NUM_TABLE_COLUMN, NUM_APP_PLAYER_COLUMN, PLAYER_COLUMN, RESULT_COLUMN, 
	NUM_APP_ADV_COLUMN, ADV_COLUMN, N_TABLE_COLUMNS};
enum { P_NUM_APP_COLUMN, P_SURNAME_COLUMN, P_NAME_COLUMN, P_ELO_COLUMN,
	P_RESULT_COLUMN, N_PLAYER_COLUMNS};

typedef struct
{
   gint     index;
   gchar *  p_text;
}
combo_data_st;

GtkWidget *pwindow;
GtkListStore *listTable;
GtkListStore *listPlayer;
GtkTreeModel *modelTable;
GtkTreeModel *modelPlayer;

gboolean *resultValidate, *roundAlreadyPaired, *matchGet;
gboolean newMatch;
struct player * listPlayerDisplay;

int g_nbRound, g_round, g_nbRoundValidated;
char nameTournament[SIZE_NAME];
char nameArbiter[SIZE_NAME];

void insertPlayerInList();
static void menuitem_response (GtkWidget *, gchar *);
void newTournament(GtkWidget *widget, gpointer data);
void file_ok_sel(GtkWidget *widget, GtkFileSelection *fs);
void destroy (GtkWidget *widget, gpointer *data);
void openFile(GtkWidget *widget, gpointer data);
void calculPairing(GtkWidget *widget, gpointer data);
void afficherPairing(GtkWidget *widget, gpointer data);
void addPlayer(GtkWidget *widget, gpointer data);
void saisieResultatPartie(int numPlayer);
void saisieResultat(GtkWidget *widget, gpointer data);
void afficherResultat(GtkWidget *widget, gpointer data);
int ajout_menu(const gchar* nomMenu, const gchar* typeMenu,
		GtkWidget *root_menu, GtkWidget *menu,
		void (*f)(GtkWidget *widget, gpointer data));
void saisieMatch(GtkTreeView *view, GtkTreeSelection *selection);
#endif
